Subject: Method security is also evaluating abstract classes

Description

| want to secure all controllers in my vendor namespace except controllers named LoginController, for that | use the following pointcut
expression:

ApplicationControllers: 'method(Beech\.*\Controller\.*(?<!Login)Controller->.*Action())’
This did not work at all (webredirect forwards me to the LoginController, and as access is denied on the LoginController chrome stops
with a TOO_MANY_REDIRECTS).
Some more debugging learned me that the security framework denied access to the abstract class AbstractController (from which the
LoginController extends). Implementing all methods from the abstract class in the LoginController does not solve this. Only extending

from a class not matching the pattern \TYPO3\FLOW3\Mvc\Controller\ActionController) solves the issue and has the expected result.

Imagine the more general pattern: .*\Controller\.*(?<!Login)Controller->.*Action(), this would even match the
\TYPOS\FLOW3\Mvc\Controlle\ActionController and thus block all access.

Question is: Shouldn't the Security Framework only evaluate the actual classnames being used?

History

#1 - 2012-12-12 09:55 - Karsten Dambekalns
- Project changed from TYPOS3 Flow Base Distribution to TYPOS.Flow

#2 - 2012-12-12 09:56 - Karsten Dambekalns

- Category set to Security
- Has patch set to No

So access is denied because your LoginController extends AbstractController and that parent classname is used when matching the expression?
Correct?

#3 - 2012-12-12 10:01 - Rens Admiraal

The parent is also matched... it seems like all classes a class inherits from are also taken into account which would be incorrect.

| would expect it would only affect the class with the exact name matching the pattern, and should not take into account any inheritance whatsoever
#4 - 2012-12-13 12:35 - Karsten Dambekalns

- Affected Flow version changed from Git 1.2 (master) to Git master
#5 - 2013-01-19 21:55 - Karsten Dambekalns

- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
